package com.gliacloud.gliaplayer;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import static io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import static io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;
import io.flutter.plugin.platform.PlatformView;

import com.gliacloud.adplayer.GliaPlayer;

public class GliaPlayerView implements PlatformView, MethodCallHandler, Application.ActivityLifecycleCallbacks {
    private final GliaPlayer _gliaPlayer;
    private final Activity _activity;

    GliaPlayerView(Context context, PluginRegistry.Registrar registrar) {
        _gliaPlayer = new GliaPlayer(context);
        _activity = registrar.activity();
        _activity.getApplication().registerActivityLifecycleCallbacks(this);

        final MethodChannel methodChannel = new MethodChannel(registrar.messenger(), "gliaplayer");
        methodChannel.setMethodCallHandler(this);
    }

    @Override
    public View getView() {
        return _gliaPlayer;
    }

    @Override
    public void onMethodCall(MethodCall methodCall, MethodChannel.Result result) {
        switch (methodCall.method) {
            case "load":
                load(methodCall, result);
                break;
            default:
                result.notImplemented();
        }

    }

    private void load(MethodCall methodCall, Result result) {
        final String slot = methodCall.argument("slot");
        final String article = methodCall.argument("article");
        _gliaPlayer.load(_activity, slot, article);
        result.success(null);
    }

    @Override
    public void dispose() {}

    @Override
    public void onActivityCreated(Activity activity, Bundle savedInstanceState) {}

    @Override
    public void onActivityStarted(Activity activity) {}

    @Override
    public void onActivityResumed(Activity activity) {
        _gliaPlayer.onResume();
    }

    @Override
    public void onActivityPaused(Activity activity) {
        _gliaPlayer.onPause();
    }

    @Override
    public void onActivityStopped(Activity activity) {}

    @Override
    public void onActivitySaveInstanceState(Activity activity, Bundle outState) {}

    @Override
    public void onActivityDestroyed(Activity activity) {}
}
