package com.gliacloud.gliaplayer;

import android.app.Activity;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

import com.gliacloud.adplayer.GliaAd;

import java.util.ArrayList;

/** GliaplayerPlugin */
public class GliaplayerPlugin implements MethodCallHandler {
  private final Activity _activity;

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "gliaplayer");
    channel.setMethodCallHandler(new GliaplayerPlugin(registrar.activity()));
    registrar
            .platformViewRegistry()
            .registerViewFactory("gliaplayer", new GliaPlayerViewFactory(registrar));
  }

  private GliaplayerPlugin(Activity activity) {
    _activity = activity;
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    switch (call.method) {
      case "getPlatformVersion":
        result.success("Android " + android.os.Build.VERSION.RELEASE);
      case "initGliaSDK":
        final ArrayList<String> dartList = call.argument("adNetworks");
        final String[] adNetworks = dartList.toArray(new String[dartList.size()]);
        GliaAd.initialize(_activity, adNetworks);
        result.success("GliaSDK inited");
      default:
        result.notImplemented();
    }
  }
}
