import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:gliaplayer/gliaplayer.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _inited = 'Unknown';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String inited;
    // Platform messages may fail, so we use a try/catch PlatformException.
    try {
      inited = await GliaPlayer.initGliaSDK(["mopub"]);
    } on PlatformException catch(e) {
//      platformVersion = 'Failed to get platform version.';
      inited = e.message;
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _inited = inited;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: Text(_inited),
        ),
        body: Center(
            child: GliaPlayer(
              onGliaPlayerCreated: _onGliaPlayerCreated,
            ),
        ),
      ),
    );
  }

  void _onGliaPlayerCreated(GliaPlayerController controller) {
    controller.load("amaze_blog_mobile", "wow-japan.com");
  }
}
